/**************************************************************************
 *                                                                        *
 *                                                                        *
 *          This code is copyright (c) 1992                               *
 *                     Athena Design, Inc.                                *
 *                     and David Pollak                                   *
 *                                                                        *
 *                ALL RIGHTS RESERVED                                     *
 *                                                                        *
 *                                                                        *
 *                                                                        *
 *                                                                        *
 *                                                                        *
 **************************************************************************/

#import "multi.h"
#import <libc.h>

@implementation MultiAddIn

+ (int)numFuncs
{
	return 2;
	}
	
+ (char *)funcName:(int)n
{
	static char *funcs[] = {"DEC","INC"};
	
	return funcs[n];
	}
	
- execute:(void *)stack numberOfParams:(int)num sheet:(void *)sh funcNumber:(int)fn
{
	AddInValue aiv;
	double n = 0;
	int error = noError;
	
	initAddInValue(&aiv);
	
	if (num != 1) pushErrorOnStack(stack,badFormulaError);
	else {
		popValueFromStack(stack,&aiv);
		n = getAddInValueNumber(&aiv,&error);
		if (error != noError) pushErrorOnStack(stack,error);
		else {
			if (fn == 0) pushNumberOnStack(stack,n - 1);
			else if (fn == 1) pushNumberOnStack(stack,n + 1);
			}
		}
	
	freeAddInValue(&aiv);
	return self;
	}

@end
